<template>
    <div>
        <b-carousel id="img-carousel"
            ref="imgCarousel"
            :interval="0"
            controls
            @sliding-start="changeImg"
            label-prev="Imagen previa"
            label-next="Imagen siguiente"
            label-goto-slide="Ir a imagen"
            label-indicators="Selecciona una imagen para mostrar"            
        >
            <b-carousel-slide v-for="(image, i) in images" :key="i">
                <template v-slot:img>
                    <img
                        v-img:product
                        :src="image"
                        :alt="product"
                    >
                </template>            
            </b-carousel-slide>
        </b-carousel>

        <b-container class="p-4">
            <b-row class="justify-content-center">
                <b-col v-for="(image, i) in thumbs" :key="i" class="text-center mb-3" cols="4" md="3">
                    <b-img thumbnail fluid :src="image" :alt="`Imagen {i}`" @click="changeImg(i)" :class="{inactive: activeImgIndex != i}" />
                </b-col>
            </b-row>
        </b-container>
    </div>
</template>

<style lang="scss">
    img.img-thumbnail {
        border: none;
        border-radius: 0;
        padding: 0;
        cursor: pointer;
        max-height: 80px;
    }
    img {
        object-fit: cover;
        object-position: center;
        width: 100%;
        max-height: 350px;
        border-radius: 0;
        &.inactive {
            opacity: 0.5;
        }
        &:hover {
            ∫opacity: 1;
        }
    }
</style>

<script>
    import { BCarousel, BCarouselSlide, BContainer, BRow, BCol, BImg  } from 'bootstrap-vue'
    import VueImg from 'v-img'

    export default {
        props: {
            product: {
                type: String,
                required: true
            },            
            images: {
                type: Array,
                required: true
            },
            thumbs: {
                type: Array,
                required: true
            }
        },
        data() {
            return {
                activeImgIndex: 0
            };
        },
        components: {
            'b-carousel': BCarousel,
            'b-carousel-slide': BCarouselSlide,
            'b-container': BContainer,
            'b-row': BRow,
            'b-col': BCol,
            'b-img': BImg,
            'v-img': VueImg
        },
        methods: {
            changeImg(index) {
                this.$refs.imgCarousel.setSlide(index);
                this.setActiveImgIndex(index);
            },
            setActiveImgIndex(index) {
                this.activeImgIndex = index;
            }
        }
    }
</script>
